## Top Level API Objects

- v1.Job

- v1.JobList

## Definitions

### v1.APIResourceList

APIResourceList is a list of APIResource, it is used to expose the name of the resources supported in a specific group and version, and if the resource is namespaced.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#resources | false | string |
groupVersion | groupVersion is the group and version this APIResourceList is for. | true | string |
resources | resources contains the name of the resources and if they are namespaced. | true | v1.APIResource array |

### v1.Affinity

Affinity is a group of affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
nodeAffinity | Describes node affinity scheduling rules for the pod. | false | v1.NodeAffinity |
podAffinity | Describes pod affinity scheduling rules (e.g. co-locate this pod in the same node, zone, etc. as some other pod(s)). | false | v1.PodAffinity |
podAntiAffinity | Describes pod anti-affinity scheduling rules (e.g. avoid putting this pod in the same node, zone, etc. as some other pod(s)). | false | v1.PodAntiAffinity |

### v1.PhotonPersistentDiskVolumeSource

Represents a Photon Controller persistent disk resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
pdID | ID that identifies Photon Controller persistent disk | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |

### v1.NodeSelectorTerm

A null or empty node selector term matches no objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
matchExpressions | Required. A list of node selector requirements. The requirements are ANDed. | true | v1.NodeSelectorRequirement array |

### v1.Preconditions

Preconditions must be fulfilled before an operation (update, delete, etc.) is carried out.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
uid | Specifies the target UID. | false | types.UID |

### v1.Status

Status is a return value for calls that don’t return other objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#resources | false | string |
metadata | Standard list metadata. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | v1.ListMeta |
status | Status of the operation. One of: "Success" or "Failure". More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#spec-and-status | false | string |
message | A human-readable description of the status of this operation. | false | string |
reason | A machine-readable description of why this operation is in the "Failure" status. If this value is empty there is no information available. A Reason clarifies an HTTP status code but does not override it. | false | string |
details | Extended data associated with the reason. Each reason may define its own extended details. This field is optional and the data returned is not guaranteed to conform to any schema except that defined by the reason type. | false | v1.StatusDetails |
code | Suggested HTTP return code for this status, 0 if not set. | false | integer (int32) |

### v1.SELinuxOptions

SELinuxOptions are the labels to be applied to the container

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
user | User is a SELinux user label that applies to the container. | false | string |
role | Role is a SELinux role label that applies to the container. | false | string |
type | Type is a SELinux type label that applies to the container. | false | string |
level | Level is SELinux level label that applies to the container. | false | string |

### v1.ObjectFieldSelector

ObjectFieldSelector selects an APIVersioned field of an object.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
apiVersion | Version of the schema the FieldPath is written in terms of, defaults to "v1". | false | string |
fieldPath | Path of the field to select in the specified API version. | true | string |

### v1.VolumeMount

VolumeMount describes a mounting of a Volume within a container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | This must match the Name of a Volume. | true | string |
readOnly | Mounted read-only if true, read-write otherwise (false or unspecified). Defaults to false. | false | boolean | false
mountPath | Path within the container at which the volume should be mounted. Must not contain :. | true | string |
subPath | Path within the volume from which the container’s volume should be mounted. Defaults to "" (volume’s root). | false | string |

### v1.NFSVolumeSource

Represents an NFS mount that lasts the lifetime of a pod. NFS volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
server | Server is the hostname or IP address of the NFS server. More info: http://kubernetes.io/docs/user-guide/volumes#nfs | true | string |
path | Path that is exported by the NFS server. More info: http://kubernetes.io/docs/user-guide/volumes#nfs | true | string |
readOnly | ReadOnly here will force the NFS export to be mounted with read-only permissions. Defaults to false. More info: http://kubernetes.io/docs/user-guide/volumes#nfs | false | boolean | false

### v1.LabelSelector

A label selector is a label query over a set of resources. The result of matchLabels and matchExpressions are ANDed. An empty label selector matches all objects. A null label selector matches no objects.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
matchLabels | matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels map is equivalent to an element of matchExpressions, whose key field is "key", the operator is "In", and the values array contains only "value". The requirements are ANDed. | false | object |
matchExpressions | matchExpressions is a list of label selector requirements. The requirements are ANDed. | false | v1.LabelSelectorRequirement array |

### v1.CephFSVolumeSource

Represents a Ceph Filesystem mount that lasts the lifetime of a pod Cephfs volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
monitors | Required: Monitors is a collection of Ceph monitors More info: http://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | true | string array |
path | Optional: Used as the mounted root, rather than the full Ceph tree, default is / | false | string |
user | Optional: User is the rados user name, default is admin More info: http://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | string |
secretFile | Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret More info: http://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | string |
secretRef | Optional: SecretRef is reference to the authentication secret for User, default is empty. More info: http://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | v1.LocalObjectReference |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: http://releases.k8s.io/HEAD/examples/volumes/cephfs/README.md#how-to-use-it | false | boolean | false

### v1.HTTPHeader

HTTPHeader describes a custom header to be used in HTTP probes

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | The header field name | true | string |
value | The header field value | true | string |

### v1.FCVolumeSource

Represents a Fibre Channel volume. Fibre Channel volumes can only be mounted as read/write once. Fibre Channel volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
targetWWNs | Required: FC target worldwide names (WWNs) | true | string array |
lun | Required: FC target lun number | true | integer (int32) |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### v1.DownwardAPIVolumeSource

DownwardAPIVolumeSource represents a volume containing downward API info. Downward API volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
items | Items is a list of downward API volume file | false | v1.DownwardAPIVolumeFile array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.PodAntiAffinity

Pod anti affinity is a group of inter pod anti affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | NOT YET IMPLEMENTED. TODO: Uncomment field once it is implemented. If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system will try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. RequiredDuringSchedulingRequiredDuringExecution []PodAffinityTerm `json:"requiredDuringSchedulingRequiredDuringExecution,omitempty"` If the anti-affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the anti-affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. | false | v1.PodAffinityTerm array |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the anti-affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling anti-affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. | false | v1.WeightedPodAffinityTerm array |

### v1.GCEPersistentDiskVolumeSource

Represents a Persistent Disk resource in Google Compute Engine.

A GCE PD must exist before mounting to a container. The disk must also be in the same GCE project and zone as the kubelet. A GCE PD can only be mounted as read/write once or read-only many times. GCE PDs support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
pdName | Unique name of the PD resource in GCE. Used to identify the disk in GCE. More info: http://kubernetes.io/docs/user-guide/volumes#gcepersistentdisk | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: http://kubernetes.io/docs/user-guide/volumes#gcepersistentdisk | false | string |
partition | The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). More info: http://kubernetes.io/docs/user-guide/volumes#gcepersistentdisk | false | integer (int32) |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: http://kubernetes.io/docs/user-guide/volumes#gcepersistentdisk | false | boolean | false

### v1.TCPSocketAction

TCPSocketAction describes an action based on opening a socket

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
port | Number or name of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. | true | string |

### v1.ConfigMapVolumeSource

Adapts a ConfigMap into a volume.

The contents of the target ConfigMap’s Data field will be presented in a volume as files using the keys in the Data field as the file names, unless the items element is populated with specific mappings of keys to paths. ConfigMap volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced ConfigMap will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the ConfigMap, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |
optional | Specify whether the ConfigMap or it’s keys must be defined | false | boolean | false

### v1.GitRepoVolumeSource

Represents a volume that is populated with the contents of a git repository. Git repo volumes do not support ownership management. Git repo volumes support SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
repository | Repository URL | true | string |
revision | Commit hash for the specified revision. | false | string |
directory | Target directory name. Must not contain or start with ... If . is supplied, the volume directory will be the git repository. Otherwise, if specified, the volume will contain the git repository in the subdirectory with the given name. | false | string |

### v1.HTTPGetAction

HTTPGetAction describes an action based on HTTP Get requests.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Path to access on the HTTP server. | false | string |
port | Name or number of the port to access on the container. Number must be in the range 1 to 65535. Name must be an IANA_SVC_NAME. | true | string |
host | Host name to connect to, defaults to the pod IP. You probably want to set "Host" in httpHeaders instead. | false | string |
scheme | Scheme to use for connecting to the host. Defaults to HTTP. | false | string |
httpHeaders | Custom headers to set in the request. HTTP allows repeated headers. | false | v1.HTTPHeader array |

### v1.SecretEnvSource

SecretEnvSource selects a Secret to populate the environment variables with.

The contents of the target Secret’s Data field will represent the key-value pairs as environment variables.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
optional | Specify whether the Secret must be defined | false | boolean | false

### v1.StatusDetails

StatusDetails is a set of additional properties that MAY be set by the server to provide additional information about a response. The Reason field of a Status object defines what attributes will be set. Clients must ignore fields that do not match the defined type of each attribute, and should assume that any attribute may be empty, invalid, or under defined.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | The name attribute of the resource associated with the status StatusReason (when there is a single name which can be described). | false | string |
group | The group attribute of the resource associated with the status StatusReason. | false | string |
kind | The kind attribute of the resource associated with the status StatusReason. On some operations may differ from the requested resource Kind. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
causes | The Causes array includes more details associated with the StatusReason failure. Not all StatusReasons may provide detailed causes. | false | v1.StatusCause array |
retryAfterSeconds | If specified, the time in seconds before the operation should be retried. | false | integer (int32) |

### v1.Capabilities

Adds and removes POSIX capabilities from running containers.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
add | Added capabilities | false | v1.Capability array |
drop | Removed capabilities | false | v1.Capability array |

### v1.LocalObjectReference

LocalObjectReference contains enough information to let you locate the referenced object inside the same namespace.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |

### v1.Container

A single application container that you want to run within a pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the container specified as a DNS_LABEL. Each container in a pod must have a unique name (DNS_LABEL). Cannot be updated. | true | string |
image | Docker image name. More info: http://kubernetes.io/docs/user-guide/images | false | string |
command | Entrypoint array. Not executed within a shell. The docker image’s ENTRYPOINT is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container’s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/containers#containers-and-commands | false | string array |
args | Arguments to the entrypoint. The docker image’s CMD is used if this is not provided. Variable references $(VAR_NAME) are expanded using the container’s environment. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/containers#containers-and-commands | false | string array |
workingDir | Container’s working directory. If not specified, the container runtime’s default will be used, which might be configured in the container image. Cannot be updated. | false | string |
ports | List of ports to expose from the container. Exposing a port here gives the system additional information about the network connections a container uses, but is primarily informational. Not specifying a port here DOES NOT prevent that port from being exposed. Any port which is listening on the default "0.0.0.0" address inside a container will be accessible from the network. Cannot be updated. | false | v1.ContainerPort array |
envFrom | List of sources to populate environment variables in the container. The keys defined within a source must be a C_IDENTIFIER. An invalid key will prevent the container from starting. When a key exists in multiple sources, the value associated with the last source will take precedence. Values defined by an Env with a duplicate key will take precedence. Cannot be updated. | false | v1.EnvFromSource array |
env | List of environment variables to set in the container. Cannot be updated. | false | v1.EnvVar array |
resources | Compute Resources required by this container. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/persistent-volumes#resources | false | v1.ResourceRequirements |
volumeMounts | Pod volumes to mount into the container’s filesystem. Cannot be updated. | false | v1.VolumeMount array |
livenessProbe | Periodic probe of container liveness. Container will be restarted if the probe fails. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/pod-states#container-probes | false | v1.Probe |
readinessProbe | Periodic probe of container service readiness. Container will be removed from service endpoints if the probe fails. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/pod-states#container-probes | false | v1.Probe |
lifecycle | Actions that the management system should take in response to container lifecycle events. Cannot be updated. | false | v1.Lifecycle |
terminationMessagePath | Optional: Path at which the file to which the container’s termination message will be written is mounted into the container’s filesystem. Message written is intended to be brief final status, such as an assertion failure message. Will be truncated by the node if greater than 4096 bytes. The total message length across all containers will be limited to 12kb. Defaults to /dev/termination-log. Cannot be updated. | false | string |
terminationMessagePolicy | Indicate how the termination message should be populated. File will use the contents of terminationMessagePath to populate the container status message on both success and failure. FallbackToLogsOnError will use the last chunk of container log output if the termination message file is empty and the container exited with an error. The log output is limited to 2048 bytes or 80 lines, whichever is smaller. Defaults to File. Cannot be updated. | false | string |
imagePullPolicy | Image pull policy. One of Always, Never, IfNotPresent. Defaults to Always if :latest tag is specified, or IfNotPresent otherwise. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/images#updating-images | false | string |
securityContext | Security options the pod should run with. More info: http://releases.k8s.io/HEAD/docs/design/security_context.md | false | v1.SecurityContext |
stdin | Whether this container should allocate a buffer for stdin in the container runtime. If this is not set, reads from stdin in the container will always result in EOF. Default is false. | false | boolean | false
stdinOnce | Whether the container runtime should close the stdin channel after it has been opened by a single attach. When stdin is true the stdin stream will remain open across multiple attach sessions. If stdinOnce is set to true, stdin is opened on container start, is empty until the first client attaches to stdin, and then remains open and accepts data until the client disconnects, at which time stdin is closed and remains closed until the container is restarted. If this flag is false, a container processes that reads from stdin will never receive an EOF. Default is false | false | boolean | false
tty | Whether this container should allocate a TTY for itself, also requires stdin to be true. Default is false. | false | boolean | false

### v1.PodSecurityContext

PodSecurityContext holds pod-level security attributes and common container settings. Some fields are also present in container.securityContext. Field values of container.securityContext take precedence over field values of PodSecurityContext.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
seLinuxOptions | The SELinux context to be applied to all containers. If unspecified, the container runtime will allocate a random SELinux context for each container. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. | false | v1.SELinuxOptions |
runAsUser | The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence for that container. | false | integer (int64) |
runAsNonRoot | Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in SecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | boolean | false
supplementalGroups | A list of groups applied to the first process run in each container, in addition to the container’s primary GID. If unspecified, no groups will be added to any container. | false | integer (int32) array |
fsGroup | A special supplemental group that applies to all containers in a pod. Some volume types allow the Kubelet to change the ownership of that volume to be owned by the pod: 1. The owning GID will be the FSGroup 2. The setgid bit is set (new files created in the volume will be owned by FSGroup) 3. The permission bits are OR’d with rw-rw | false | integer (int64) |

### v1.ExecAction

ExecAction describes a "run in container" action.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
command | Command is the command line to execute inside the container, the working directory for the command is root (/) in the container’s filesystem. The command is simply exec’d, it is not run inside a shell, so traditional shell instructions (' | ', etc) won’t work. To use a shell, you need to explicitly call out to that shell. Exit status of 0 is treated as live/healthy and non-zero is unhealthy. | false | string array

### v1.JobStatus

JobStatus represents the current state of a Job.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
conditions | Conditions represent the latest available observations of an object’s current state. More info: http://kubernetes.io/docs/user-guide/jobs | false | v1.JobCondition array |
startTime | StartTime represents time when the job was acknowledged by the Job Manager. It is not guaranteed to be set in happens-before order across separate operations. It is represented in RFC3339 form and is in UTC. | false | string |
completionTime | CompletionTime represents time when the job was completed. It is not guaranteed to be set in happens-before order across separate operations. It is represented in RFC3339 form and is in UTC. | false | string |
active | Active is the number of actively running pods. | false | integer (int32) |
succeeded | Succeeded is the number of pods which reached Phase Succeeded. | false | integer (int32) |
failed | Failed is the number of pods which reached Phase Failed. | false | integer (int32) |

### v1.ObjectMeta

ObjectMeta is metadata that all persisted resources must have, which includes all objects users must create.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name must be unique within a namespace. Is required when creating resources, although some resources may allow a client to request the generation of an appropriate name automatically. Name is primarily intended for creation idempotence and configuration definition. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
generateName | GenerateName is an optional prefix, used by the server, to generate a unique name ONLY IF the Name field has not been provided. If this field is used, the name returned to the client will be different than the name passed. This value will also be combined with a unique suffix. The provided value has the same validation rules as the Name field, and may be truncated by the length of the suffix required to make the value unique on the server. If this field is specified and the generated name exists, the server will NOT return a 409 - instead, it will either return 201 Created or 500 with Reason ServerTimeout indicating a unique name could not be found in the time allotted, and the client should retry (optionally after the time indicated in the Retry-After header). Applied only if Name is not specified. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#idempotency | false | string |
namespace | Namespace defines the space within each name must be unique. An empty namespace is equivalent to the "default" namespace, but "default" is the canonical representation. Not all objects are required to be scoped to a namespace - the value of this field for those objects will be empty. Must be a DNS_LABEL. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/namespaces | false | string |
selfLink | SelfLink is a URL representing this object. Populated by the system. Read-only. | false | string |
uid | UID is the unique in time and space value for this object. It is typically generated by the server on successful creation of a resource and is not allowed to change on PUT operations. Populated by the system. Read-only. More info: http://kubernetes.io/docs/user-guide/identifiers#uids | false | string |
resourceVersion | An opaque value that represents the internal version of this object that can be used by clients to determine when objects have changed. May be used for optimistic concurrency, change detection, and the watch operation on a resource or set of resources. Clients must treat these values as opaque and passed unmodified back to the server. They may only be valid for a particular resource or set of resources. Populated by the system. Read-only. Value must be treated as opaque by clients and . More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#concurrency-control-and-consistency | false | string |
generation | A sequence number representing a specific generation of the desired state. Populated by the system. Read-only. | false | integer (int64) |
creationTimestamp | CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC. Populated by the system. Read-only. Null for lists. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#metadata | false | string |
deletionTimestamp | DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field. Once set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested. Populated by the system when a graceful deletion is requested. Read-only. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#metadata | false | string |
deletionGracePeriodSeconds | Number of seconds allowed for this object to gracefully terminate before it will be removed from the system. Only set when deletionTimestamp is also set. May only be shortened. Read-only. | false | integer (int64) |
labels | Map of string keys and values that can be used to organize and categorize (scope and select) objects. May match selectors of replication controllers and services. More info: http://kubernetes.io/docs/user-guide/labels | false | object |
annotations | Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects. More info: http://kubernetes.io/docs/user-guide/annotations | false | object |
ownerReferences | List of objects depended by this object. If ALL objects in the list have been deleted, this object will be garbage collected. If this object is managed by a controller, then an entry in this list will point to this controller, with the controller field set to true. There cannot be more than one managing controller. | false | v1.OwnerReference array |
finalizers | Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed. | false | string array |
clusterName | The name of the cluster which the object belongs to. This is used to distinguish resources with same name and namespace in different clusters. This field is not set anywhere right now and apiserver is going to ignore it if set in create or update request. | false | string |

### v1.OwnerReference

OwnerReference contains enough information to let you identify an owning object. Currently, an owning object must be in the same namespace, so there is no namespace field.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
apiVersion | API version of the referent. | true | string |
kind | Kind of the referent. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | true | string |
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | true | string |
uid | UID of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#uids | true | string |
controller | If true, this reference points to the managing controller. | false | boolean | false

### v1.APIResource

APIResource specifies the name of a resource and whether it is namespaced.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | name is the name of the resource. | true | string |
namespaced | namespaced indicates if a resource is namespaced or not. | true | boolean | false
kind | kind is the kind for the resource (e.g. Foo is the kind for a resource foo) | true | string |
verbs | verbs is a list of supported kube verbs (this includes get, list, watch, create, update, patch, delete, deletecollection, and proxy) | true | string array |

### v1.NodeSelectorRequirement

A node selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | The label key that the selector applies to. | true | string |
operator | Represents a key’s relationship to a set of values. Valid operators are In, NotIn, Exists, DoesNotExist. Gt, and Lt. | true | string |
values | An array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. If the operator is Gt or Lt, the values array must have a single element, which will be interpreted as an integer. This array is replaced during a strategic merge patch. | false | string array |

### types.UID

### v1.HostPathVolumeSource

Represents a host path mapped into a pod. Host path volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Path of the directory on the host. More info: http://kubernetes.io/docs/user-guide/volumes#hostpath | true | string |

### v1.AzureFileVolumeSource

AzureFile represents an Azure File Service mount on the host and bind mount to the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
secretName | the name of secret that contains Azure Storage Account Name and Key | true | string |
shareName | Share Name | true | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### v1.ISCSIVolumeSource

Represents an ISCSI disk. ISCSI volumes can only be mounted as read/write once. ISCSI volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
targetPortal | iSCSI target portal. The portal is either an IP or ip_addr:port if the port is other than default (typically TCP ports 860 and 3260). | true | string |
iqn | Target iSCSI Qualified Name. | true | string |
lun | iSCSI target lun number. | true | integer (int32) |
iscsiInterface | Optional: Defaults to default (tcp). iSCSI interface name that uses an iSCSI transport. | false | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: http://kubernetes.io/docs/user-guide/volumes#iscsi | false | string |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. | false | boolean | false

### v1.EmptyDirVolumeSource

Represents an empty directory for a pod. Empty directory volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
medium | What type of storage medium should back this directory. The default is "" which means to use the node’s default medium. Must be an empty string (default) or Memory. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir | false | string |

### v1.PodAffinityTerm

Defines a set of pods (namely those matching the labelSelector relative to the given namespace(s)) that this pod should be co-located (affinity) or not co-located (anti-affinity) with, where co-located is defined as running on a node whose value of the label with key <topologyKey> tches that of any node on which a pod of the set of pods is running

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
labelSelector | A label query over a set of resources, in this case pods. | false | v1.LabelSelector |
namespaces | namespaces specifies which namespaces the labelSelector applies to (matches against); nil list means "this pod’s namespace," empty list means "all namespaces" The json tag here is not "omitempty" since we need to distinguish nil and empty. See https://golang.org/pkg/encoding/json/#Marshal for more details. | true | string array |
topologyKey | This pod should be co-located (affinity) or not co-located (anti-affinity) with the pods matching the labelSelector in the specified namespaces, where co-located is defined as running on a node whose value of the label with key topologyKey matches that of any node on which any of the selected pods is running. For PreferredDuringScheduling pod anti-affinity, empty topologyKey is interpreted as "all topologies" ("all topologies" here means all the topologyKeys indicated by scheduler command-line argument --failure-domains); for affinity and for RequiredDuringScheduling pod anti-affinity, empty topologyKey is not allowed. | false | string |

### v1.EnvFromSource

EnvFromSource represents the source of a set of ConfigMaps

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
prefix | An optional identifer to prepend to each key in the ConfigMap. Must be a C_IDENTIFIER. | false | string |
configMapRef | The ConfigMap to select from | false | v1.ConfigMapEnvSource |
secretRef | The Secret to select from | false | v1.SecretEnvSource |

### v1.CinderVolumeSource

Represents a cinder volume resource in Openstack. A Cinder volume must exist before mounting to a container. The volume must also be in the same region as the kubelet. Cinder volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeID | volume id used to identify the volume in cinder More info: http://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: http://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | string |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. More info: http://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | boolean | false

### v1.SecurityContext

SecurityContext holds security configuration that will be applied to a container. Some fields are present in both SecurityContext and PodSecurityContext. When both are set, the values in SecurityContext take precedence.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
capabilities | The capabilities to add/drop when running containers. Defaults to the default set of capabilities granted by the container runtime. | false | v1.Capabilities |
privileged | Run container in privileged mode. Processes in privileged containers are essentially equivalent to root on the host. Defaults to false. | false | boolean | false
seLinuxOptions | The SELinux context to be applied to the container. If unspecified, the container runtime will allocate a random SELinux context for each container. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | v1.SELinuxOptions |
runAsUser | The UID to run the entrypoint of the container process. Defaults to user specified in image metadata if unspecified. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | integer (int64) |
runAsNonRoot | Indicates that the container must run as a non-root user. If true, the Kubelet will validate the image at runtime to ensure that it does not run as UID 0 (root) and fail to start the container if it does. If unset or false, no such validation will be performed. May also be set in PodSecurityContext. If set in both SecurityContext and PodSecurityContext, the value specified in SecurityContext takes precedence. | false | boolean | false
readOnlyRootFilesystem | Whether this container has a read-only root filesystem. Default is false. | false | boolean | false

### v1.PodAffinity

Pod affinity is a group of inter pod affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | NOT YET IMPLEMENTED. TODO: Uncomment field once it is implemented. If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system will try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. RequiredDuringSchedulingRequiredDuringExecution []PodAffinityTerm `json:"requiredDuringSchedulingRequiredDuringExecution,omitempty"` If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to a pod label update), the system may or may not try to eventually evict the pod from its node. When there are multiple elements, the lists of nodes corresponding to each podAffinityTerm are intersected, i.e. all terms must be satisfied. | false | v1.PodAffinityTerm array |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node has pods which matches the corresponding podAffinityTerm; the node(s) with the highest sum are the most preferred. | false | v1.WeightedPodAffinityTerm array |

### v1.PersistentVolumeClaimVolumeSource

PersistentVolumeClaimVolumeSource references the user’s PVC in the same namespace. This volume finds the bound PV and mounts that volume for the pod. A PersistentVolumeClaimVolumeSource is, essentially, a wrapper around another type of volume that is owned by someone else (the system).

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
claimName | ClaimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume. More info: http://kubernetes.io/docs/user-guide/persistent-volumes#persistentvolumeclaims | true | string |
readOnly | Will force the ReadOnly setting in VolumeMounts. Default false. | false | boolean | false

### v1.AWSElasticBlockStoreVolumeSource

Represents a Persistent Disk resource in AWS.

An AWS EBS disk must exist before mounting to a container. The disk must also be in the same AWS zone as the kubelet. An AWS EBS disk can only be mounted as read/write once. AWS EBS volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumeID | Unique ID of the persistent disk resource in AWS (Amazon EBS volume). More info: http://kubernetes.io/docs/user-guide/volumes#awselasticblockstore | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: http://kubernetes.io/docs/user-guide/volumes#awselasticblockstore | false | string |
partition | The partition in the volume that you want to mount. If omitted, the default is to mount by volume name. Examples: For volume /dev/sda1, you specify the partition as "1". Similarly, the volume partition for /dev/sda is "0" (or you can leave the property empty). | false | integer (int32) |
readOnly | Specify "true" to force and set the ReadOnly property in VolumeMounts to "true". If omitted, the default is "false". More info: http://kubernetes.io/docs/user-guide/volumes#awselasticblockstore | false | boolean | false

### v1.ListMeta

ListMeta describes metadata that synthetic resources must have, including lists and various status objects. A resource may have only one of {ObjectMeta, ListMeta}.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
selfLink | SelfLink is a URL representing this object. Populated by the system. Read-only. | false | string |
resourceVersion | String that identifies the server’s internal version of this object that can be used by clients to determine when objects have changed. Value must be treated as opaque by clients and passed unmodified back to the server. Populated by the system. Read-only. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#concurrency-control-and-consistency | false | string |

### v1.FlockerVolumeSource

Represents a Flocker volume mounted by the Flocker agent. One and only one of datasetName and datasetUUID should be set. Flocker volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
datasetName | Name of the dataset stored as metadata → name on the dataset for Flocker should be considered as deprecated | false | string |
datasetUUID | UUID of the dataset. This is unique identifier of a Flocker dataset | false | string |

### v1.QuobyteVolumeSource

Represents a Quobyte mount that lasts the lifetime of a pod. Quobyte volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
registry | Registry represents a single or multiple Quobyte Registry services specified as a string as host:port pair (multiple entries are separated with commas) which acts as the central registry for volumes | true | string |
volume | Volume is a string that references an already created Quobyte volume by name. | true | string |
readOnly | ReadOnly here will force the Quobyte volume to be mounted with read-only permissions. Defaults to false. | false | boolean | false
user | User to map volume access to Defaults to serivceaccount user | false | string |
group | Group to map volume access to Default is no group | false | string |

### v1.Job

Job represents the configuration of a single job.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#resources | false | string |
metadata | Standard object’s metadata. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#metadata | false | v1.ObjectMeta |
spec | Spec is a structure defining the expected behavior of a job. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#spec-and-status | false | v1.JobSpec |
status | Status is a structure describing current status of a job. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#spec-and-status | false | v1.JobStatus |

### v1.WatchEvent

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type |  | true | string |
object |  | true | string |

### v1.JobCondition

JobCondition describes current state of a job.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
type | Type of job condition, Complete or Failed. | true | string |
status | Status of the condition, one of True, False, Unknown. | true | string |
lastProbeTime | Last time the condition was checked. | false | string |
lastTransitionTime | Last time the condition transit from one status to another. | false | string |
reason | (brief) reason for the condition’s last transition. | false | string |
message | Human readable message indicating details about last transition. | false | string |

### v1.JobList

JobList is a collection of jobs.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#resources | false | string |
metadata | Standard list metadata More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#metadata | false | v1.ListMeta |
items | Items is the list of Job. | true | v1.Job array |

### v1.SecretVolumeSource

Adapts a Secret into a volume.

The contents of the target Secret’s Data field will be presented in a volume as files using the keys in the Data field as the file names. Secret volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
secretName | Name of the secret in the pod’s namespace to use. More info: http://kubernetes.io/docs/user-guide/volumes#secrets | false | string |
items | If unspecified, each key-value pair in the Data field of the referenced Secret will be projected into the volume as a file whose name is the key and content is the value. If specified, the listed keys will be projected into the specified paths, and unlisted keys will not be present. If a key is specified which is not present in the Secret, the volume setup will error unless it is marked optional. Paths must be relative and may not contain the .. path or start with ... | false | v1.KeyToPath array |
defaultMode | Optional: mode bits to use on created files by default. Must be a value between 0 and 0777. Defaults to 0644. Directories within the path are not affected by this setting. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |
optional | Specify whether the Secret or it’s keys must be defined | false | boolean | false

### v1.LabelSelectorRequirement

A label selector requirement is a selector that contains values, a key, and an operator that relates the key and values.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | key is the label key that the selector applies to. | true | string |
operator | operator represents a key’s relationship to a set of values. Valid operators ard In, NotIn, Exists and DoesNotExist. | true | string |
values | values is an array of string values. If the operator is In or NotIn, the values array must be non-empty. If the operator is Exists or DoesNotExist, the values array must be empty. This array is replaced during a strategic merge patch. | false | string array |

### v1.EnvVar

EnvVar represents an environment variable present in a Container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the environment variable. Must be a C_IDENTIFIER. | true | string |
value | Variable references $(VAR_NAME) are expanded using the previous defined environment variables in the container and any service environment variables. If a variable cannot be resolved, the reference in the input string will be unchanged. The $(VAR_NAME) syntax can be escaped with a double $$, ie: $$(VAR_NAME). Escaped references will never be expanded, regardless of whether the variable exists or not. Defaults to "". | false | string |
valueFrom | Source for the environment variable’s value. Cannot be used if value is not empty. | false | v1.EnvVarSource |

### v1.ResourceRequirements

ResourceRequirements describes the compute resource requirements.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
limits | Limits describes the maximum amount of compute resources allowed. More info: http://kubernetes.io/docs/user-guide/compute-resources/ | false | object |
requests | Requests describes the minimum amount of compute resources required. If Requests is omitted for a container, it defaults to Limits if that is explicitly specified, otherwise to an implementation-defined value. More info: http://kubernetes.io/docs/user-guide/compute-resources/ | false | object |

### v1.FlexVolumeSource

FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. This is an alpha feature and may change in future.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
driver | Driver is the name of the driver to use for this volume. | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". The default filesystem depends on FlexVolume script. | false | string |
secretRef | Optional: SecretRef is reference to the secret object containing sensitive information to pass to the plugin scripts. This may be empty if no secret object is specified. If the secret object contains more than one secret, all secrets are passed to the plugin scripts. | false | v1.LocalObjectReference |
readOnly | Optional: Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false
options | Optional: Extra command options if any. | false | object |

### v1.EnvVarSource

EnvVarSource represents a source for the value of an EnvVar.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
fieldRef | Selects a field of the pod: supports metadata.name, metadata.namespace, metadata.labels, metadata.annotations, spec.nodeName, spec.serviceAccountName, status.podIP. | false | v1.ObjectFieldSelector |
resourceFieldRef | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported. | false | v1.ResourceFieldSelector |
configMapKeyRef | Selects a key of a ConfigMap. | false | v1.ConfigMapKeySelector |
secretKeyRef | Selects a key of a secret in the pod’s namespace | false | v1.SecretKeySelector |

### v1.PodTemplateSpec

PodTemplateSpec describes the data a pod should have when created from a template

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
metadata | Standard object’s metadata. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#metadata | false | v1.ObjectMeta |
spec | Specification of the desired behavior of the pod. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#spec-and-status | false | v1.PodSpec |

### v1.KeyToPath

Maps a string key to a path within a volume.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
key | The key to project. | true | string |
path | The relative path of the file to map the key to. May not be an absolute path. May not contain the path element ... May not start with the string ... | true | string |
mode | Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.AzureDiskVolumeSource

AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
diskName | The Name of the data disk in the blob storage | true | string |
diskURI | The URI the data disk in the blob storage | true | string |
cachingMode | Host Caching mode: None, Read Only, Read Write. | false | v1.AzureDataDiskCachingMode |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |
readOnly | Defaults to false (read/write). ReadOnly here will force the ReadOnly setting in VolumeMounts. | false | boolean | false

### v1.NodeSelector

A node selector represents the union of the results of one or more label queries over a set of nodes; that is, it represents the OR of the selectors represented by the node selector terms.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
nodeSelectorTerms | Required. A list of node selector terms. The terms are ORed. | true | v1.NodeSelectorTerm array |

### v1.VsphereVirtualDiskVolumeSource

Represents a vSphere volume resource.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumePath | Path that identifies vSphere volume vmdk | true | string |
fsType | Filesystem type to mount. Must be a filesystem type supported by the host operating system. Ex. "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. | false | string |

### v1.JobSpec

JobSpec describes how the job execution will look like.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
parallelism | Parallelism specifies the maximum desired number of pods the job should run at any given time. The actual number of pods running in steady state will be less than this number when ((.spec.completions - .status.successful) < .spec.parallelism), i.e. when the work left to do is less than max parallelism. More info: http://kubernetes.io/docs/user-guide/jobs | false | integer (int32) |
completions | Completions specifies the desired number of successfully finished pods the job should be run with. Setting to nil means that the success of any pod signals the success of all pods, and allows parallelism to have any positive value. Setting to 1 means that parallelism is limited to 1 and the success of that pod signals the success of the job. More info: http://kubernetes.io/docs/user-guide/jobs | false | integer (int32) |
activeDeadlineSeconds | Optional duration in seconds relative to the startTime that the job may be active before the system tries to terminate it; value must be positive integer | false | integer (int64) |
selector | Selector is a label query over pods that should match the pod count. Normally, the system sets this field for you. More info: http://kubernetes.io/docs/user-guide/labels#label-selectors | false | v1.LabelSelector |
manualSelector | ManualSelector controls generation of pod labels and pod selectors. Leave `manualSelector` unset unless you are certain what you are doing. When false or unset, the system pick labels unique to this job and appends those labels to the pod template. When true, the user is responsible for picking unique labels and specifying the selector. Failure to pick a unique label may cause this and other jobs to not function correctly. However, You may see `manualSelector=true` in jobs that were created with the old `extensions/v1beta1` API. More info: http://releases.k8s.io/HEAD/docs/design/selector-generation.md | false | boolean | false
template | Template is the object that describes the pod that will be created when executing a job. More info: http://kubernetes.io/docs/user-guide/jobs | true | v1.PodTemplateSpec |

### v1.Patch

Patch is provided to give a concrete name and type to the Kubernetes PATCH request body.

### v1.DeleteOptions

DeleteOptions may be provided when deleting an API object.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
kind | Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#types-kinds | false | string |
apiVersion | APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: http://releases.k8s.io/HEAD/docs/devel/api-conventions.md#resources | false | string |
gracePeriodSeconds | The duration in seconds before the object should be deleted. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period for the specified type will be used. Defaults to a per object value if not specified. zero means delete immediately. | false | integer (int64) |
preconditions | Must be fulfilled before a deletion is carried out. If not possible, a 409 Conflict status will be returned. | false | v1.Preconditions |
orphanDependents | Should the dependent objects be orphaned. If true/false, the "orphan" finalizer will be added to/removed from the object’s finalizers list. | false | boolean | false

### v1.Volume

Volume represents a named volume in a pod that may be accessed by any container in the pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Volume’s name. Must be a DNS_LABEL and unique within the pod. More info: http://kubernetes.io/docs/user-guide/identifiers#names | true | string |
hostPath | HostPath represents a pre-existing file or directory on the host machine that is directly exposed to the container. This is generally used for system agents or other privileged things that are allowed to see the host machine. Most containers will NOT need this. More info: http://kubernetes.io/docs/user-guide/volumes#hostpath | false | v1.HostPathVolumeSource |
emptyDir | EmptyDir represents a temporary directory that shares a pod’s lifetime. More info: http://kubernetes.io/docs/user-guide/volumes#emptydir | false | v1.EmptyDirVolumeSource |
gcePersistentDisk | GCEPersistentDisk represents a GCE Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: http://kubernetes.io/docs/user-guide/volumes#gcepersistentdisk | false | v1.GCEPersistentDiskVolumeSource |
awsElasticBlockStore | AWSElasticBlockStore represents an AWS Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: http://kubernetes.io/docs/user-guide/volumes#awselasticblockstore | false | v1.AWSElasticBlockStoreVolumeSource |
gitRepo | GitRepo represents a git repository at a particular revision. | false | v1.GitRepoVolumeSource |
secret | Secret represents a secret that should populate this volume. More info: http://kubernetes.io/docs/user-guide/volumes#secrets | false | v1.SecretVolumeSource |
nfs | NFS represents an NFS mount on the host that shares a pod’s lifetime More info: http://kubernetes.io/docs/user-guide/volumes#nfs | false | v1.NFSVolumeSource |
iscsi | ISCSI represents an ISCSI Disk resource that is attached to a kubelet’s host machine and then exposed to the pod. More info: http://releases.k8s.io/HEAD/examples/volumes/iscsi/README.md | false | v1.ISCSIVolumeSource |
glusterfs | Glusterfs represents a Glusterfs mount on the host that shares a pod’s lifetime. More info: http://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md | false | v1.GlusterfsVolumeSource |
persistentVolumeClaim | PersistentVolumeClaimVolumeSource represents a reference to a PersistentVolumeClaim in the same namespace. More info: http://kubernetes.io/docs/user-guide/persistent-volumes#persistentvolumeclaims | false | v1.PersistentVolumeClaimVolumeSource |
rbd | RBD represents a Rados Block Device mount on the host that shares a pod’s lifetime. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md | false | v1.RBDVolumeSource |
flexVolume | FlexVolume represents a generic volume resource that is provisioned/attached using an exec based plugin. This is an alpha feature and may change in future. | false | v1.FlexVolumeSource |
cinder | Cinder represents a cinder volume attached and mounted on kubelets host machine More info: http://releases.k8s.io/HEAD/examples/mysql-cinder-pd/README.md | false | v1.CinderVolumeSource |
cephfs | CephFS represents a Ceph FS mount on the host that shares a pod’s lifetime | false | v1.CephFSVolumeSource |
flocker | Flocker represents a Flocker volume attached to a kubelet’s host machine. This depends on the Flocker control service being running | false | v1.FlockerVolumeSource |
downwardAPI | DownwardAPI represents downward API about the pod that should populate this volume | false | v1.DownwardAPIVolumeSource |
fc | FC represents a Fibre Channel resource that is attached to a kubelet’s host machine and then exposed to the pod. | false | v1.FCVolumeSource |
azureFile | AzureFile represents an Azure File Service mount on the host and bind mount to the pod. | false | v1.AzureFileVolumeSource |
configMap | ConfigMap represents a configMap that should populate this volume | false | v1.ConfigMapVolumeSource |
vsphereVolume | VsphereVolume represents a vSphere volume attached and mounted on kubelets host machine | false | v1.VsphereVirtualDiskVolumeSource |
quobyte | Quobyte represents a Quobyte mount on the host that shares a pod’s lifetime | false | v1.QuobyteVolumeSource |
azureDisk | AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod. | false | v1.AzureDiskVolumeSource |
photonPersistentDisk | PhotonPersistentDisk represents a PhotonController persistent disk attached and mounted on kubelets host machine | false | v1.PhotonPersistentDiskVolumeSource |

### v1.ConfigMapEnvSource

ConfigMapEnvSource selects a ConfigMap to populate the environment variables with.

The contents of the target ConfigMap’s Data field will represent the key-value pairs as environment variables.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
optional | Specify whether the ConfigMap must be defined | false | boolean | false

### v1.ResourceFieldSelector

ResourceFieldSelector represents container resources (cpu, memory) and their output format

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
containerName | Container name: required for volumes, optional for env vars | false | string |
resource | Required: resource to select | true | string |
divisor | Specifies the output format of the exposed resources, defaults to "1" | false | string |

### v1.WeightedPodAffinityTerm

The weights of all of the matched WeightedPodAffinityTerm fields are added per-node to find the most preferred node(s)

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
weight | weight associated with matching the corresponding podAffinityTerm, in the range 1-100. | true | integer (int32) |
podAffinityTerm | Required. A pod affinity term, associated with the corresponding weight. | true | v1.PodAffinityTerm |

### v1.Probe

Probe describes a health check to be performed against a container to determine whether it is alive or ready to receive traffic.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
exec | One and only one of the following should be specified. Exec specifies the action to take. | false | v1.ExecAction |
httpGet | HTTPGet specifies the http request to perform. | false | v1.HTTPGetAction |
tcpSocket | TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported | false | v1.TCPSocketAction |
initialDelaySeconds | Number of seconds after the container has started before liveness probes are initiated. More info: http://kubernetes.io/docs/user-guide/pod-states#container-probes | false | integer (int32) |
timeoutSeconds | Number of seconds after which the probe times out. Defaults to 1 second. Minimum value is 1. More info: http://kubernetes.io/docs/user-guide/pod-states#container-probes | false | integer (int32) |
periodSeconds | How often (in seconds) to perform the probe. Default to 10 seconds. Minimum value is 1. | false | integer (int32) |
successThreshold | Minimum consecutive successes for the probe to be considered successful after having failed. Defaults to 1. Must be 1 for liveness. Minimum value is 1. | false | integer (int32) |
failureThreshold | Minimum consecutive failures for the probe to be considered failed after having succeeded. Defaults to 3. Minimum value is 1. | false | integer (int32) |

### v1.SecretKeySelector

SecretKeySelector selects a key of a Secret.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
key | The key of the secret to select from. Must be a valid secret key. | true | string |
optional | Specify whether the Secret or it’s key must be defined | false | boolean | false

### v1.NodeAffinity

Node affinity is a group of node affinity scheduling rules.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
requiredDuringSchedulingIgnoredDuringExecution | If the affinity requirements specified by this field are not met at scheduling time, the pod will not be scheduled onto the node. If the affinity requirements specified by this field cease to be met at some point during pod execution (e.g. due to an update), the system may or may not try to eventually evict the pod from its node. | false | v1.NodeSelector |
preferredDuringSchedulingIgnoredDuringExecution | The scheduler will prefer to schedule pods to nodes that satisfy the affinity expressions specified by this field, but it may choose a node that violates one or more of the expressions. The node that is most preferred is the one with the greatest sum of weights, i.e. for each node that meets all of the scheduling requirements (resource request, requiredDuringScheduling affinity expressions, etc.), compute a sum by iterating through the elements of this field and adding "weight" to the sum if the node matches the corresponding matchExpressions; the node(s) with the highest sum are the most preferred. | false | v1.PreferredSchedulingTerm array |

### v1.Capability

### v1.PreferredSchedulingTerm

An empty preferred scheduling term matches all objects with implicit weight 0 (i.e. it’s a no-op). A null preferred scheduling term matches no objects (i.e. is also a no-op).

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
weight | Weight associated with matching the corresponding nodeSelectorTerm, in the range 1-100. | true | integer (int32) |
preference | A node selector term, associated with the corresponding weight. | true | v1.NodeSelectorTerm |

### v1.DownwardAPIVolumeFile

DownwardAPIVolumeFile represents information to create the file containing the pod field

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
path | Required: Path is the relative path name of the file to be created. Must not be absolute or contain the .. path. Must be utf-8 encoded. The first item of the relative path must not start with .. | true | string |
fieldRef | Required: Selects a field of the pod: only annotations, labels, name and namespace are supported. | false | v1.ObjectFieldSelector |
resourceFieldRef | Selects a resource of the container: only resources limits and requests (limits.cpu, limits.memory, requests.cpu and requests.memory) are currently supported. | false | v1.ResourceFieldSelector |
mode | Optional: mode bits to use on this file, must be a value between 0 and 0777. If not specified, the volume defaultMode will be used. This might be in conflict with other options that affect the file mode, like fsGroup, and the result can be other mode bits set. | false | integer (int32) |

### v1.PodSpec

PodSpec is a description of a pod.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
volumes | List of volumes that can be mounted by containers belonging to the pod. More info: http://kubernetes.io/docs/user-guide/volumes | false | v1.Volume array |
containers | List of containers belonging to the pod. Containers cannot currently be added or removed. There must be at least one container in a Pod. Cannot be updated. More info: http://kubernetes.io/docs/user-guide/containers | true | v1.Container array |
restartPolicy | Restart policy for all containers within the pod. One of Always, OnFailure, Never. Default to Always. More info: http://kubernetes.io/docs/user-guide/pod-states#restartpolicy | false | string |
terminationGracePeriodSeconds | Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request. Value must be non-negative integer. The value zero indicates delete immediately. If this value is nil, the default grace period will be used instead. The grace period is the duration in seconds after the processes running in the pod are sent a termination signal and the time when the processes are forcibly halted with a kill signal. Set this value longer than the expected cleanup time for your process. Defaults to 30 seconds. | false | integer (int64) |
activeDeadlineSeconds | Optional duration in seconds the pod may be active on the node relative to StartTime before the system will actively try to mark it failed and kill associated containers. Value must be a positive integer. | false | integer (int64) |
dnsPolicy | Set DNS policy for containers within the pod. One of ClusterFirst or Default. Defaults to "ClusterFirst". | false | string |
nodeSelector | NodeSelector is a selector which must be true for the pod to fit on a node. Selector which must match a node’s labels for the pod to be scheduled on that node. More info: http://kubernetes.io/docs/user-guide/node-selection/README | false | object |
serviceAccountName | ServiceAccountName is the name of the ServiceAccount to use to run this pod. More info: http://releases.k8s.io/HEAD/docs/design/service_accounts.md | false | string |
serviceAccount | DeprecatedServiceAccount is a depreciated alias for ServiceAccountName. Deprecated: Use serviceAccountName instead. | false | string |
nodeName | NodeName is a request to schedule this pod onto a specific node. If it is non-empty, the scheduler simply schedules this pod onto that node, assuming that it fits resource requirements. | false | string |
hostNetwork | Host networking requested for this pod. Use the host’s network namespace. If this option is set, the ports that will be used must be specified. Default to false. | false | boolean | false
hostPID | Use the host’s pid namespace. Optional: Default to false. | false | boolean | false
hostIPC | Use the host’s ipc namespace. Optional: Default to false. | false | boolean | false
securityContext | SecurityContext holds pod-level security attributes and common container settings. Optional: Defaults to empty. See type description for default values of each field. | false | v1.PodSecurityContext |
imagePullSecrets | ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec. If specified, these secrets will be passed to individual puller implementations for them to use. For example, in the case of docker, only DockerConfig type secrets are honored. More info: http://kubernetes.io/docs/user-guide/images#specifying-imagepullsecrets-on-a-pod | false | v1.LocalObjectReference array |
hostname | Specifies the hostname of the Pod If not specified, the pod’s hostname will be set to a system-defined value. | false | string |
subdomain | If specified, the fully qualified Pod hostname will be "<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>". If not specified, the pod will not have a domainname at all. | false | string |
affinity | If specified, the pod’s scheduling constraints | false | v1.Affinity |
schedulername | If specified, the pod will be dispatched by specified scheduler. If not specified, the pod will be dispatched by default scheduler. | false | string |

### v1.ContainerPort

ContainerPort represents a network port in a single container.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | If specified, this must be an IANA_SVC_NAME and unique within the pod. Each named port in a pod must have a unique name. Name for the port that can be referred to by services. | false | string |
hostPort | Number of port to expose on the host. If specified, this must be a valid port number, 0 < x < 65536. If HostNetwork is specified, this must match ContainerPort. Most containers do not need this. | false | integer (int32) |
containerPort | Number of port to expose on the pod’s IP address. This must be a valid port number, 0 < x < 65536. | true | integer (int32) |
protocol | Protocol for port. Must be UDP or TCP. Defaults to "TCP". | false | string |
hostIP | What host IP to bind the external port to. | false | string |

### v1.Lifecycle

Lifecycle describes actions that the management system should take in response to container lifecycle events. For the PostStart and PreStop lifecycle handlers, management of the container blocks until the action is complete, unless the container process fails, in which case the handler is aborted.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
postStart | PostStart is called immediately after a container is created. If the handler fails, the container is terminated and restarted according to its restart policy. Other management of the container blocks until the hook completes. More info: http://kubernetes.io/docs/user-guide/container-environment#hook-details | false | v1.Handler |
preStop | PreStop is called immediately before a container is terminated. The container is terminated after the handler completes. The reason for termination is passed to the handler. Regardless of the outcome of the handler, the container is eventually terminated. Other management of the container blocks until the hook completes. More info: http://kubernetes.io/docs/user-guide/container-environment#hook-details | false | v1.Handler |

### v1.ConfigMapKeySelector

Selects a key from a ConfigMap.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
name | Name of the referent. More info: http://kubernetes.io/docs/user-guide/identifiers#names | false | string |
key | The key to select. | true | string |
optional | Specify whether the ConfigMap or it’s key must be defined | false | boolean | false

### v1.Handler

Handler defines a specific action that should be taken

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
exec | One and only one of the following should be specified. Exec specifies the action to take. | false | v1.ExecAction |
httpGet | HTTPGet specifies the http request to perform. | false | v1.HTTPGetAction |
tcpSocket | TCPSocket specifies an action involving a TCP port. TCP hooks not yet supported | false | v1.TCPSocketAction |

### v1.GlusterfsVolumeSource

Represents a Glusterfs mount that lasts the lifetime of a pod. Glusterfs volumes do not support ownership management or SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
endpoints | EndpointsName is the endpoint name that details Glusterfs topology. More info: http://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | true | string |
path | Path is the Glusterfs volume path. More info: http://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | true | string |
readOnly | ReadOnly here will force the Glusterfs volume to be mounted with read-only permissions. Defaults to false. More info: http://releases.k8s.io/HEAD/examples/volumes/glusterfs/README.md#create-a-pod | false | boolean | false

### v1.StatusCause

StatusCause provides more information about an api.Status failure, including cases when multiple errors are encountered.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
reason | A machine-readable description of the cause of the error. If this value is empty there is no information available. | false | string |
message | A human-readable description of the cause of the error. This field may be presented as-is to a reader. | false | string |
field | The field of the resource that has caused this error, as named by its JSON serialization. May include dot and postfix notation for nested attributes. Arrays are zero-indexed. Fields may appear more than once in an array of causes due to fields having multiple errors. Optional. Examples: "name" - the field "name" on the current resource "items[0].name" - the field "name" on the first array entry in "items" | false | string |

### v1.AzureDataDiskCachingMode

### v1.RBDVolumeSource

Represents a Rados Block Device mount that lasts the lifetime of a pod. RBD volumes support ownership management and SELinux relabeling.

Name | Description | Required | Schema | Default
--- | --- | --- | --- | ---
monitors | A collection of Ceph monitors. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | true | string array |
image | The rados image name. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | true | string |
fsType | Filesystem type of the volume that you want to mount. Tip: Ensure that the filesystem type is supported by the host operating system. Examples: "ext4", "xfs", "ntfs". Implicitly inferred to be "ext4" if unspecified. More info: http://kubernetes.io/docs/user-guide/volumes#rbd | false | string |
pool | The rados pool name. Default is rbd. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it. | false | string |
user | The rados user name. Default is admin. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | string |
keyring | Keyring is the path to key ring for RBDUser. Default is /etc/ceph/keyring. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | string |
secretRef | SecretRef is name of the authentication secret for RBDUser. If provided overrides keyring. Default is nil. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | v1.LocalObjectReference |
readOnly | ReadOnly here will force the ReadOnly setting in VolumeMounts. Defaults to false. More info: http://releases.k8s.io/HEAD/examples/volumes/rbd/README.md#how-to-use-it | false | boolean | false

### any

Represents an untyped JSON map - see the description of the field for more info about the structure of this object.